de.caff.util.settings

## Class AbstractBasicEnumValue<E>

- java.lang.Object
- - java.lang.Number
  - - de.caff.util.settings.AbstractBasicEnumValue<E>

- All Implemented Interfaces:
    EnumValue<E>, java.io.Serializable
  Direct Known Subclasses:
    EnumEnumValue, IntegerEnumValue

      abstract class AbstractBasicEnumValue<E>
      extends java.lang.Number
      implements EnumValue<E>

  Base class used for enum values.
  Author:
    Rammi

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractBasicEnumValue(java.lang.String baseTag)` Create an abstract basic enum value.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `EnumValue<E>` | `getBasicValue()` Get the basic enum value.
    `javax.swing.Icon` | `getIcon(java.util.Locale l)` Get a possible icon to display for this value.
    `java.lang.String` | `getLongName(java.util.Locale l)` Get a longer description which describes this value.
    `java.lang.String` | `getShortName(java.util.Locale l)` Get a human readable name for this enum value.

    - ### Methods inherited from class java.lang.Number

      `byteValue, doubleValue, floatValue, intValue, longValue, shortValue`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface de.caff.util.settings.EnumValue

      `getRealValue, isEqualTo, storeTo`

- - ### Constructor Detail

    - #### AbstractBasicEnumValue

          protected AbstractBasicEnumValue(java.lang.String baseTag)

      Create an abstract basic enum value.
      Parameters:
        `baseTag` - basic i18n tag

  - ### Method Detail

    - #### getShortName

          @NotNull
          public java.lang.String getShortName(@Nullable
                                                        java.util.Locale l)

      Get a human readable name for this enum value.
      Specified by:
        `getShortName` in interface `EnumValue<E>`
      Parameters:
        `l` - locale to use
      Returns:
        human readable short name

    - #### getLongName

          public java.lang.String getLongName(@Nullable
                                              java.util.Locale l)

      Get a longer description which describes this value.
      Specified by:
        `getLongName` in interface `EnumValue<E>`
      Parameters:
        `l` - locale to use
      Returns:
        human readable description or `null` if no description is available

    - #### getIcon

          public javax.swing.Icon getIcon(@Nullable
                                          java.util.Locale l)

      Get a possible icon to display for this value.
      Specified by:
        `getIcon` in interface `EnumValue<E>`
      Parameters:
        `l` - locale to use
      Returns:
        icon or `null` if no icon is available

    - #### getBasicValue

          public EnumValue<E> getBasicValue()

      Get the basic enum value. This is needed when wrappers are used.
      Returns:
        basic value